using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Threading;

namespace ClockMark
{
	static class Program
	{
        // ensure that there is only one instance of the application at
        // any given moment
        private static Mutex mutOtherInstance;

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.EnableVisualStyles();
			Application.SetCompatibleTextRenderingDefault(false);

            mutOtherInstance = new Mutex(true, "WebComicReaderApp");

            if (mutOtherInstance.WaitOne(0, false))
            {
                // no other instances
                Application.Run(new frmClockMark());
            }
            else
            {
                // there are other instances
                Application.Exit();
            }
			
		}
	}
}