﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Reflection;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace ClockMark
{
	partial class frmAboutBox : Form
	{
		private static frmAboutBox _childInstance = null;

		#region rounded corners
		[DllImport("Gdi32.dll", EntryPoint = "CreateRoundRectRgn")]
		private static extern IntPtr CreateRoundRectRgn
		(
			int nLeftRect, // x-coordinate of upper-left corner
			int nTopRect, // y-coordinate of upper-left corner
			int nRightRect, // x-coordinate of lower-right corner
			int nBottomRect, // y-coordinate of lower-right corner
			int nWidthEllipse, // height of ellipse
			int nHeightEllipse // width of ellipse
		);
		#endregion rounded corners

		private frmAboutBox()
		{
			InitializeComponent();

			this.Region = System.Drawing.Region.FromHrgn(
				CreateRoundRectRgn(0, 0,
					this.Width, this.Height,
					20, 20));
		}

		public static frmAboutBox GetChild()
		{
			if (_childInstance == null)
				_childInstance = new frmAboutBox();

			return _childInstance;
		}

		private void frmAboutBox_MouseClick(object sender, MouseEventArgs e)
		{
			this.Close();
		}

		private void frmAboutBox_KeyPress(object sender, KeyPressEventArgs e)
		{
			if ((e.KeyChar == (char)Keys.Escape) ||
				(e.KeyChar == (char)Keys.Enter))
			{
				this.Close();
			}
		}

		private void llbPerunSoft_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
		{
			try
			{
				llbPerunSoft.LinkVisited = true;
				System.Diagnostics.Process.Start(llbPerunSoft.Text);
			}
			catch (Exception ex)
			{
				MessageBox.Show("Unable to open " + llbPerunSoft.Text + ".\r\n" + ex.Message);
			}
		}

		private void llbSourceForge_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
		{
			try
			{
				llbSourceForge.LinkVisited = true;
				System.Diagnostics.Process.Start(llbSourceForge.Text);
			}
			catch (Exception ex)
			{
				MessageBox.Show("Unable to open " + llbSourceForge.Text + ".\r\n" + ex.Message);
			}
		}
	}
}
