﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ClockMark
{
	public partial class frmNewAlarm : Form
	{
        private frmClockMark frmParent;
		private static frmNewAlarm _childInstance = null;

        private frmNewAlarm(frmClockMark frmParent)
		{
			InitializeComponent();

			this.frmParent = frmParent;
            this.Icon = Properties.Resources.ClockMark;

            // default values;
            this.cbOccurence.SelectedIndex = this.cbOccurence.Items.IndexOf("Once");
            this.nudMin.Value = 15;
		}

        public static frmNewAlarm GetChild(frmClockMark frmParent)
		{
			if (_childInstance == null)
				_childInstance = new frmNewAlarm(frmParent);

			return _childInstance;
		}

        private void cbPlaySound_CheckedChanged(object sender, EventArgs e)
        {
            if (this.cbPlaySound.Checked)
            {
                this.tbPlaySoundFile.Enabled = true;
                this.btChoosePlaySoundFile.Enabled = true;
            }
            else
            {
                this.tbPlaySoundFile.Enabled = false;
                this.btChoosePlaySoundFile.Enabled = false;
            }
        }

        private void btChooseSoundFile_Click(object sender, EventArgs e)
        {

        }

        private void cbExecApp_CheckedChanged(object sender, EventArgs e)
        {
            if (this.cbExecApp.Checked)
            {
                this.tbExecAppFile.Enabled = true;
                this.btChooseExecAppFile.Enabled = true;
            }
            else
            {
                this.tbExecAppFile.Enabled = false;
                this.btChooseExecAppFile.Enabled = false;
            }
        }

        private void btChooseAppFile_Click(object sender, EventArgs e)
        {
        }

        private void cbShutdownPC_CheckedChanged(object sender, EventArgs e)
        {
            if (this.cbShutdownPC.Checked)
            {
            }
            else
            {
            }
        }

        private void btOK_Click(object sender, EventArgs e)
        {
            this.SaveAlarm();
            this.Close();
        }

        private void btCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void tbName_TextChanged(object sender, EventArgs e)
        {
            if (this.tbName.Text.Length == 0)
            {
                this.tbName.Text = "New Alarm";
                this.tbName.SelectAll();
            }
        }

        private void tbName_Click(object sender, EventArgs e)
        {
            if (this.tbName.Text.CompareTo("New Alarm") == 0)
                this.tbName.SelectAll();
        }

        private void SaveAlarm()
        {
            ushort[] days = new ushort[7] { 0, 0, 0, 0, 0, 0, 0 };

            foreach (ListViewItem lviDay in this.lvDays.SelectedItems)
            {
                switch (lviDay.Name)
                {
                    case "Monday":
                        days[0] = 1;
                        break;
                    case "Tuesday":
                        days[1] = 1;
                        break;
                    case "Wednesday":
                        days[2] = 1;
                        break;
                    case "Thursday":
                        days[3] = 1;
                        break;
                    case "Friday":
                        days[4] = 1;
                        break;
                    case "Saturday":
                        days[5] = 1;
                        break;
                    case "Sunday":
                        days[6] = 1;
                        break;
                    default:
                        break;
                }
            }

            Alarm newAlarm = new Alarm(
                this.tbName.Text,
                this.tbDescription.Text,
                (Occurence) this.cbOccurence.SelectedIndex,
                this.dtpTime.Value,
                this.dtpDate.Value.Date,
                (ushort) this.nudMin.Value,
                days,
                this.cbPlaySound.Checked,
                this.tbPlaySoundFile.Text,
                this.cbExecApp.Checked,
                this.tbExecAppFile.Text,
                this.cbShutdownPC.Checked);

            this.frmParent.ClockMarkAlarms.AddAlarm(newAlarm);
            this.frmParent.ClockMarkAlarms.SaveAlarms();
        }

        private void cbOccurence_SelectedIndexChanged(object sender, EventArgs e)
        {
            switch (this.cbOccurence.SelectedIndex)
            {
                case 0: // once
                    this.dtpTime.Enabled = true;
                    this.dtpDate.Enabled = true;
                    this.nudMin.Enabled = false;
                    this.lvDays.Enabled = false;
                    break;
                case 1: // minutely
                    this.dtpTime.Enabled = true;
                    this.dtpDate.Enabled = false;
                    this.nudMin.Enabled = true;
                    this.lvDays.Enabled = false;
                    break;
                case 2: // hourly
                    this.dtpTime.Enabled = true;
                    this.dtpDate.Enabled = false;
                    this.nudMin.Enabled = false;
                    this.lvDays.Enabled = false;
                    break;
                case 3: // daily
                    this.dtpTime.Enabled = true;
                    this.dtpDate.Enabled = false;
                    this.nudMin.Enabled = false;
                    this.lvDays.Enabled = false;
                    break;
                case 4: // weekly
                    this.dtpTime.Enabled = true;
                    this.dtpDate.Enabled = false;
                    this.nudMin.Enabled = false;
                    this.lvDays.Enabled = true;
                    break;
                case 5: // monthly
                    this.dtpTime.Enabled = true;
                    this.dtpDate.Enabled = true;
                    this.nudMin.Enabled = false;
                    this.lvDays.Enabled = false;
                    break;
                case 6: // yearly
                    this.dtpTime.Enabled = true;
                    this.dtpDate.Enabled = true;
                    this.nudMin.Enabled = false;
                    this.lvDays.Enabled = false;
                    break;
                default: // set to once
                    this.dtpTime.Enabled = true;
                    this.dtpDate.Enabled = true;
                    this.nudMin.Enabled = false;
                    this.lvDays.Enabled = false;
                    break;
            }
        }
	}
}
