using System;
using System.Collections.Generic;
using System.ServiceModel;
using System.Text;

// A WCF service consists of a contract (defined below), 
// a class which implements that interface, and configuration 
// entries that specify behaviors and endpoints associated with 
// that implementation (see <system.serviceModel> in your application
// configuration file).

namespace ClockMarkHost
{
    internal class ClockMarkServiceHost
    {
        internal static ServiceHost svcHostClockMark = null;

        internal static void StartService()
        {
            //Consider putting the baseAddress in the configuration system
            //and getting it here with AppSettings
            Uri baseAddress = new Uri("http://localhost:5555/ClockMarkService");

            Console.WriteLine("The ClockMark service Uri is [" + baseAddress.ToString() + "].");

            //Instantiate new ServiceHost 
            svcHostClockMark = new ServiceHost(typeof(ClockMarkServer.ClockMarkServiceType), baseAddress);

            //Open myServiceHost
            svcHostClockMark.Open();
        }

        internal static void StopService()
        {
            //Call StopService from your shutdown logic (i.e. dispose method)
            if (svcHostClockMark.State != CommunicationState.Closed)
                svcHostClockMark.Close();
        }
    }
}